import { CursorPagedResponse, PagedResponse, PagingRequest, JSONString, InvalidParametersError } from "@snickerdoodlelabs/objects";
import { ResultAsync } from "neverthrow";
export declare class ObjectUtils {
    static mergeDeep<T = unknown>(...objects: any[]): T;
    static serialize(obj: unknown): JSONString;
    static deserialize<T = Record<string, unknown>>(json: JSONString): T;
    static toGenericObject(obj: unknown): Record<string, unknown>;
    static iteratePages<T, TError, TError2>(readFunc: (pagingRequest: PagingRequest) => ResultAsync<PagedResponse<T>, TError>, processFunc: (obj: T) => ResultAsync<void, TError2>, pageSize?: number): ResultAsync<void, TError | TError2>;
    private static fetchAndProcessPage;
    static iterateCursor<T, TCursor, TError>(readFunc: (cursor: TCursor | null) => ResultAsync<CursorPagedResponse<T[], TCursor>, TError>, handler: (data: T[]) => ResultAsync<void, TError>): ResultAsync<void, TError>;
    static parseBoolean(val: string | number | boolean): boolean;
    private static processNextBatch;
    static removeNullValues<T>(array: (T | null | undefined)[]): T[];
    static progressiveFallback<TReturn, TProvider, TError>(method: (TProvider: any) => ResultAsync<TReturn, TError>, provider: TProvider[]): ResultAsync<TReturn, TError | InvalidParametersError>;
}
//# sourceMappingURL=ObjectUtils.d.ts.map