var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ISO8601DateString, MillisecondTimestamp, UnixTimestamp, } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
let TimeUtils = class TimeUtils {
    constructor() { }
    getUnixNow() {
        return UnixTimestamp(Math.floor(Date.now() / 1000));
    }
    getMillisecondNow() {
        return MillisecondTimestamp(Date.now());
    }
    getISO8601TimeString(time = MillisecondTimestamp(Date.now())) {
        return ISO8601DateString(new Date(time).toISOString());
    }
    convertTimestampToISOString(unixTimestamp) {
        const date = new Date(unixTimestamp * 1000);
        return ISO8601DateString(date.toISOString());
    }
    getUnixTodayStart() {
        const date = new Date();
        date.setHours(0, 0, 0, 0);
        return UnixTimestamp(Math.floor(date.getTime() / 1000));
    }
    getUnixTodayEnd() {
        const date = new Date();
        date.setHours(23, 59, 59, 999);
        return UnixTimestamp(Math.floor(date.getTime() / 1000));
    }
};
TimeUtils = __decorate([
    injectable(),
    __metadata("design:paramtypes", [])
], TimeUtils);
export { TimeUtils };
//# sourceMappingURL=TimeUtils.js.map